from __future__ import print_function
# -*- coding: utf-8 -*-
#http://docs.scipy.org/doc/numpy/reference/generated/numpy.matrix.html
#http://docs.scipy.org/doc/numpy/reference/routines.linalg.html

#On travaille ici avec des <class 'numpy.ndarray'>
# getA transforme <class 'numpy.matrixlib.defmatrix.matrix'> en <class 'numpy.ndarray'>
# marche peut etre avec <class 'numpy.matrixlib.defmatrix.matrix'>
_FonctionDuProgramme="travail avec les matrices\n"
#print(_FonctionDuProgramme)
_Version="1.0"
##################### debug
_debug=True # 
_debug=False
def dprint(ligne):
	if _debug==True:
		print(ligne)
		print('--------------------------')


# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""

import numpy
from numpy import *#array,zeros,ones,getH



class CVecteur(object):
	""" CLASSE CVecteur """
	def __init__(self,n=3,v=None):
		self._v=Vecteur(n)
		if v!=None and n==len(v):			
			for j in range(n):
				self._v[i]=v[i]
		return self._v
		
	
	def ProduitScalaire(self,v):
		return ProduitScalaire
		

def MatmnNulle(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return numpy.matrix(numpy.zeros((m,n)))
	
def MatnNulle(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return MatmnNulle(n,n)
		
def MatmnUn(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return numpy.matrix(ones((m,n)))

def MatnUn(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	return MatmnUn(n,n)

def MatnUnite(n=1):#<class 'numpy.ndarray'> # lignes , colonnes
	M=MatnNulle(n).getA()
	for i in range(n):
		M[i][i]=1.0
	return numpy.matrix(M)


















def MatriceCarree(M):#<class 'bool'>
	if (M.shape)[0]==(M.shape)[1]:
		return True
	else:
		return False	

def Dimensions(M):#<class 'tuple'>
	return ( (M.shape)[0] , (M.shape)[1] )



def Determinant(M):#<class 'numpy.float64'>
	if MatriceCarree(M)==True:
		return numpy.linalg.det(M)
	else:
		print('(EE) Determinant : matrice non carree')
		return None

def Conjuguee(M):
	return (numpy.matrix(M).getH()).getA()	

def Transposee(M):
	return (numpy.matrix(M).getT()).getA()
	
def SousMatrice(M,a,b):#on enleve ligne a colonne b
	dim=Dimensions(M)
	N=MatmnNulle(dim[0]-1,dim[1]-1)#<class 'numpy.ndarray'>	
	for i in range(dim[0]):
		if i<a:
			ii=i
		else:
			ii=i-1
		for j in range(dim[1]):
			if j<b:
				jj=j
			else:
				jj=j-1	
			if i!=a and j!=b:
				N[ii][jj]=M[i][j]			
	return N

def DeterminantParSousMatrices(M):
	N=Dimensions(M)[0]
	if N>1:
		det=0.0
		for i in range(N):
			det+=(1-2*(i%2))*M[0][i]*DeterminantParSousMatrices(SousMatrice(M,0,i))
			#print(i,(1-2*(i%2)),DeterminantParSousMatrices(SousMatrice(M,0,i)))
		return det	
	else:
		return M[0][0]
		
def MatFoisMat(M1,M2):
	p,q=Dimensions(M1)
	q,r=Dimensions(M2)
	M3=MatmnNulle(p,r)	
	for i in range(p):
		for j in range(r):
			s=0.0
			for k in range(q):
				s+=M1[i][k]*M2[k][j]
		M3[i][j]=s
	return M3	
	
def ProduitScalaire(A,B):	
	if len(A) != len(B):
		return None
	else:
		s=0.0
		for i in range(len(A)):
			s+=A[i][0]*B[i][0]
		return float(s)

def Norme(A):
	return sqrt(ProduitScalaire(A,A))
	
def DiagonalisationParPuissance(M):	

	def puissance(A,tol,nmax):
		n=len(A)
		y=MatmnNulle(n,1)
		y[1][0]=1
		v=ProduitScalaire(y,A*y)
		print("y",y)
		print("A*y",A*y)
		res=tol+1
		niter=1
		
		while (res>=tol)and(niter<=nmax):
			Ay=A*y
			vy=v*y
			Ay_vy=Ay-vy
			res=Norme(Ay_vy)
			y=A*y
			norm_y=Norme(y)
			y=( 1.0/norm_y ) * y 
			v=ProduitScalaire(y,A*y)
			niter+=1
			if niter>nmax:
				return None		
		return v,y
			

	def deflation(A,tol,niter):		
		n=len(A)
		v,y=puissance(A,tol,niter)
		list_vp=[v]
		list_yp=[y]
		for compteur in range(n-1):	
			#print("compteur,n=",compteur,n)		
			#A=[[A[i][j]-v*y[i]*y[j] for j in range(n)] for i in range(n)]
			#A=numpy.matrix(A)	
			print(A)
			print(v*y*		Transposee(y))

			A=A-v*y*Transposee(y)
			v,y=puissance(A,tol,niter)
			list_vp.append(v)
			list_yp.append(y)
		
		return list_vp,list_yp


	
	ValeursPropres,VecteursPropres=deflation(M,1.0E-8,1e6)
	print(' **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** **** ')
	N=len(M)
	
	MatriceDiagonale=MatmnNulle(N,N).getA()
	MatriceDeTransition=MatmnNulle(N,N).getA()
	for i in range(N):
		MatriceDiagonale[i][i]=ValeursPropres[i]
	for i in range(N):
		for j in range(N):
			MatriceDeTransition[i][j]=VecteursPropres[j][i]
	return ValeursPropres,VecteursPropres,numpy.matrix(MatriceDiagonale),numpy.matrix(MatriceDeTransition) #M= MDT * D * MDT-1
	
def Vecteur(n):
	return MatmnNulle(n,1)

def Vecteur3(x=0,y=0,z=0):
	v=Vecteur(3)
	v[0],v[1],v[2]=x,y,z
	return v


	
	
global main

if __name__ == "__main__":
	
	print("from CMatrixMatrices import * ")
	
	print("def MatriceCarree(M):#<class 'bool'>")
	print("def Dimensions(M):#<class 'tuple'>")
	print("def MatmnNulle(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnNulle(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatmnUn(m=1,n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnUn(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def MatnUnite(n=1):#<class 'numpy.ndarray'> # lignes , colonnes")
	print("def Determinant(M):#<class 'numpy.float64'>")
	print("def Conjuguee(M):")
	print("def Transposee(M):")
	print("def SousMatrice(M,a,b):#on enleve ligne a colonne b")
	print("def DeterminantParSousMatrices(M):")
	print("def MatFoisMat(M1,M2):")
	print("def ProduitScalaire(A,B):	")
	print("def Norme(A):")
	print("def DiagonalisationParPuissance(M):	")
	print("	def puissance(A,tol,nmax):")
	print("	def deflation(A,tol,niter):		")
	print("	ValeursPropres,VecteursPropres=deflation(M,1.0E-8,1e6)")
	print("def Vecteur(n):")
	print("def Vecteur3(x=0,y=0,z=0):")
	
	exit()
	
	
	"""
	M1=MatmnNulle(1,5)
	M2=MatmnNulle(5,1)
	M=[[2.0, 5.0], [0.0, 4.0]]
	D=numpy.matrix([[2.0, 0.0], [0.0, 4.0]])
	P=numpy.matrix('[1.,5.;0.0,2.]')
	print("d=",D)
	print("p=",P)
	print("p-1=",P.getI())
	print("PP-1=",P*P.getI())
	print("PDP-1=",P*D*P.getI())
	#print("P-1DP=",P.getI()*D*P)
	print("DP-1=",D*P.getI())
	"""
	print('diagonalisation')
	M=numpy.matrix([[0.5,0.25], [2.0,2.0]])
	ValeursPropres,VecteursPropres,D,P=DiagonalisationParPuissance(M)
	print("ValeursPropres")
	print(ValeursPropres)
	print("VecteursPropres")
	print(VecteursPropres)
	print("D")
	print(D)
	print("P")
	print(P)

	print(ValeursPropres[1] * VecteursPropres[1] , M*VecteursPropres[1] )

'''
M = numpy.matrix('[1,1,1,1,1,1,1,1;1,1,1,1,0,0,0,0;1,0,1,0,1,0,1,0;1,1,0,0,1,1,0,0;1,0,1,0,0,0,0,0;1,1,0,0,0,0,0,0;1,0,0,0,1,0,0,0;1,0,0,0,0,0,0,0]')
#B = M A  A = M-1 B
B=numpy.matrix('[800;300;352;424;188;166;208;144]')
print()
print(M.getI() * B)
print(numpy.linalg.det(M))
'''

'''
M=MatnUnite(3)
for i in range(3):
	for j in range(3):
		M[i][j]=(1+i)*j**3
'''
		
"""
M=MatnUnite(3)
print(Determinant(M))
print(DeterminantParSousMatrices(M))
"""


'''
print(type(MatriceCarree(M)))
print(type(Dimensions(M)))
print(type(MatmnNulle(m=1,n=1)))
print(type(MatnNulle(n=1)))
print(type(MatnUnite(n=1)))
print(type(Determinant(M)))
print(type(Conjuguee(M)))
print(type(Transposee(M)))

print(M)
print(SousMatrice(M,2,1))

M=MatmnUn(3,3)
N=MatmnUn(3,3)
#print(N*M)

'''


'''Methods
all([axis, out]) 	Test whether all matrix elements along a given axis evaluate to True.
any([axis, out]) 	Test whether any array element along a given axis evaluates to True.
argmax([axis, out]) 	Indices of the maximum values along an axis.
argmin([axis, out]) 	Return the indices of the minimum values along an axis.
argpartition(kth[, axis, kind, order]) 	Returns the indices that would partition this array.
argsort([axis, kind, order]) 	Returns the indices that would sort this array.
astype(dtype[, order, casting, subok, copy]) 	Copy of the array, cast to a specified type.
byteswap(inplace) 	Swap the bytes of the array elements
choose(choices[, out, mode]) 	Use an index array to construct a new array from a set of choices.
clip(a_min, a_max[, out]) 	Return an array whose values are limited to [a_min, a_max].
compress(condition[, axis, out]) 	Return selected slices of this array along given axis.
conj() 	Complex-conjugate all elements.
conjugate() 	Return the complex conjugate, element-wise.
copy([order]) 	Return a copy of the array.
cumprod([axis, dtype, out]) 	Return the cumulative product of the elements along the given axis.
cumsum([axis, dtype, out]) 	Return the cumulative sum of the elements along the given axis.
diagonal([offset, axis1, axis2]) 	Return specified diagonals.
dot(b[, out]) 	Dot product of two arrays.
dump(file) 	Dump a pickle of the array to the specified file.
dumps() 	Returns the pickle of the array as a string.
fill(value) 	Fill the array with a scalar value.
flatten([order]) 	Return a copy of the array collapsed into one dimension.
getA() 	Return self as an ndarray object.
getA1() 	Return self as a flattened ndarray.
getH() 	Returns the (complex) conjugate transpose of self.
getI() 	Returns thrns the (multiplicative) inverse of invertible self.
getT() 	Retue transpose of the matrix.
getfield(dtype[, offset]) 	Returns a field of the given array as a certain type.
item(*args) 	Copy an element of an array to a standard Python scalar and return it.
itemset(*args) 	Insert scalar into an array (scalar is cast to array's dtype, if possible)
max([axis, out]) 	Return the maximum value along an axis.
mean([axis, dtype, out]) 	Returns the average of the matrix elements along the given axis.
min([axis, out]) 	Return the minimum value along an axis.
newbyteorder([new_order]) 	Return the array with the same data viewed with a different byte order.
nonzero() 	Return the indices of the elements that are non-zero.
partition(kth[, axis, kind, order]) 	Rearranges the elements in the array in such a way that value of the element in kth position is in the position it would be in a sorted array.
prod([axis, dtype, out]) 	Return the product of the array elements over the given axis.
ptp([axis, out]) 	Peak-to-peak (maximum - minimum) value along the given axis.
put(indices, values[, mode]) 	Set a.flat[n] = values[n] for all n in indices.
ravel([order]) 	Return a flattened array.
repeat(repeats[, axis]) 	Repeat elements of an array.
reshape(shape[, order]) 	Returns an array containing the same data with a new shape.
resize(new_shape[, refcheck]) 	Change shape and size of array in-place.
round([decimals, out]) 	Return a with each element rounded to the given number of decimals.
searchsorted(v[, side, sorter]) 	Find indices where elements of v should be inserted in a to maintain order.
setfield(val, dtype[, offset]) 	Put a value into a specified place in a field defined by a data-type.
setflags([write, align, uic]) 	Set array flags WRITEABLE, ALIGNED, and UPDATEIFCOPY, respectively.
sort([axis, kind, order]) 	Sort an array, in-place.
squeeze([axis]) 	Remove single-dimensional entries from the shape of a.
std([axis, dtype, out, ddof]) 	Return the standard deviation of the array elements along the given axis.
sum([axis, dtype, out]) 	Returns the sum of the matrix elements, along the given axis.
swapaxes(axis1, axis2) 	Return a view of the array with axis1 and axis2 interchanged.
take(indices[, axis, out, mode]) 	Return an array formed from the elements of a at the given indices.
tobytes([order]) 	Construct Python bytes containing the raw data bytes in the array.
tofile(fid[, sep, format]) 	Write array to a file as text or binary (default).
tolist() 	Return the matrix as a (possibly nested) list.
tostring([order]) 	Construct Python bytes containing the raw data bytes in the array.
trace([offset, axis1, axis2, dtype, out]) 	Return the sum along diagonals of the array.
transpose(*axes) 	Returns a view of the array with axes transposed.
var([axis, dtype, out, ddof]) 	Returns the variance of the matrix elements, along the given axis.
view([dtype, type]) 	New view of array with the same data.
'''

'''
Attributes
A 	Return self as an ndarray object.
A1 	Return self as a flattened ndarray.
H 	Returns the (complex) conjugate transpose of self.
I 	Returns the (multiplicative) inverse of invertible self.
T 	Returns the transpose of the matrix.
base 	Base object if memory is from some other object.
ctypes 	An object to simplify the interaction of the array with the ctypes module.
data 	Python buffer object pointing to the start of the array’s data.
dtype 	Data-type of the array’s elements.
flags 	Information about the memory layout of the array.
flat 	A 1-D iterator over the array.
imag 	The imaginary part of the array.
itemsize 	Length of one array element in bytes.
nbytes 	Total bytes consumed by the elements of the array.
ndim 	Number of array dimensions.
real 	The real part of the array.
shape 	Tuple of array dimensions.
size 	Number of elements in the array.
strides 	Tuple of bytes to step in each dimension when traversing an array.
'''
